Attribute VB_Name = "modBolt"
'******************************************************************'
'*                                                                *'
'*                      TurboCAD for Windows                      *'
'*                   Copyright (c) 1993 - 2001                    *'
'*             International Microcomputer Software, Inc.         *'
'*                            (IMSI)                              *'
'*                      All rights reserved.                      *'
'*                                                                *'
'******************************************************************'

' This sample draw different types of Bolts
'DBAPI constants
Const gkGraphic = 11
Const gkGroup = 7 ' imsiGroup
Const gkArc = 2
Const gkText = 6
Const gfCosmetic = 128&

'Useful math constants
Const Pi# = 3.14159265


' Hexagon Bolt Hexagon Bolt Hexagon Bolt Hexagon Bolt Hexagon Bolt Hexagon Bolt
' Hexagon Bolt Hexagon Bolt Hexagon Bolt Hexagon Bolt Hexagon Bolt Hexagon Bolt

Public Sub HexBolt()

Dim App As Application
Dim ActDr As Drawing
Dim Grs As Graphics
Dim Gr As Graphic
Dim grfChild As Graphic
    Set App = IMSIGX.Application 'returns the application - TurboCAD
    Set ActDr = App.ActiveDrawing 'returns the current active drawing in the TurboCAd
    Set Grs = ActDr.Graphics ' returns the graphics collection on the active drawing
    Set Gr = Grs.Add(gkGroup) ' add new graphic to the graphics collection
    
    
Dim X0#, Y0#, X1#, Y1#, t#
Dim D#, L#, E#, F#, s#, del#, dd#
Dim W#, H#
    
    X0# = 2#
    Y0# = 2#
    frmBolt.Image1.Visible = True
    frmBolt.Image2.Visible = False
    frmBolt.Image3.Visible = False
    frmBolt.Show
   
    dd = CDbl(frmBolt.TextBox1.Text)
    L = CDbl(frmBolt.TextBox2.Text)

               
    D# = 1.75 * dd#
    H# = 0.65 * dd#
    E# = 0.8 * H#
    F# = D# / 4#
    s# = (L# - H#) / 2#
    del# = 0.1 * dd#
' add child graphics to parent graphic - Gr
'1
 Set grfChild = Gr.Graphics.AddLineSingle(X0#, Y0# + dd# / 2#, 0, X0# + L# - del#, Y0# + dd# / 2#, 0)
'2
 Set grfChild = Gr.Graphics.AddLineSingle(X0# + L# - del#, Y0# + dd# / 2#, 0, X0# + L# - del#, Y0# - dd# / 2#, 0)
'3
 Set grfChild = Gr.Graphics.AddLineSingle(X0#, Y0# - dd# / 2#, 0, X0# + L# - del#, Y0# - dd# / 2#, 0)
'4
 Set grfChild = Gr.Graphics.AddLineSingle(X0#, Y0# + D# / 2#, 0, X0#, Y0# - D# / 2#, 0)
'5
 Set grfChild = Gr.Graphics.AddLineSingle(X0#, Y0# + F#, 0, X0# - E#, Y0# + F#, 0)
'6
 Set grfChild = Gr.Graphics.AddLineSingle(X0#, Y0# - F#, 0, X0# - E#, Y0# - F#, 0)
'7
 Set grfChild = Gr.Graphics.AddLineSingle(X0# + (L# - s#), Y0# + dd# / 2#, 0, X0# + (L# - s#), Y0# - dd# / 2#, 0)
'8
 Set grfChild = Gr.Graphics.AddLineSingle(X0# + (L# - del#), Y0# + dd# / 2#, 0, X0# + L#, Y0# + dd# / 2# - del#, 0)
'9
 Set grfChild = Gr.Graphics.AddLineSingle(X0# + L#, Y0# + dd# / 2# - del#, 0, X0# + L#, Y0# - dd# / 2# + del#, 0)
'10
 Set grfChild = Gr.Graphics.AddLineSingle(X0# + (L# - del#), Y0# - dd# / 2#, 0, X0# + L#, Y0# - dd# / 2# + del#, 0)
'11
 Set grfChild = Gr.Graphics.AddArcTriplePoint(X0# - E#, Y0# + F#, 0, X0# - H#, Y0# + (D# / 2# + F#) / 2#, 0, X0# - E#, Y0# + D# / 2#, 0)
'12
 Set grfChild = Gr.Graphics.AddArcTriplePoint(X0# - E#, Y0# - F#, 0, X0# - H#, Y0# - (D# / 2# + F#) / 2#, 0, X0# - E#, Y0# - D# / 2#, 0)
'13
 Set grfChild = Gr.Graphics.AddArcTriplePoint(X0# - E#, Y0# + F#, 0, X0# - H#, Y0#, 0, X0# - E#, Y0# - F#, 0)
'14
 Set grfChild = Gr.Graphics.AddLineSingle(X0# + (L# - s#), Y0# + dd# / 2# - del#, 0, X0# + L#, Y0# + dd# / 2# - del#, 0)
'15
 Set grfChild = Gr.Graphics.AddLineSingle(X0# + (L# - s#), Y0# - dd# / 2# + del#, 0, X0# + L#, Y0# - dd# / 2# + del#, 0)
'16
 Set grfChild = Gr.Graphics.AddLineSingle(X0# - H#, Y0# + D# / 2# - (H# - E#), 0, X0# - H#, Y0# - D# / 2# + (H# - E#), 0)
'17
 Set grfChild = Gr.Graphics.AddLineSingle(X0#, Y0# + D# / 2#, 0, X0# - E#, Y0# + D# / 2#, 0)
'18
 Set grfChild = Gr.Graphics.AddLineSingle(X0# - E#, Y0# + D# / 2#, 0, X0# - H#, Y0# + D# / 2# - (H# - E#), 0)
'19
 Set grfChild = Gr.Graphics.AddLineSingle(X0#, Y0# - D# / 2#, 0, X0# - E#, Y0# - D# / 2#, 0)
'20
 Set grfChild = Gr.Graphics.AddLineSingle(X0# - E#, Y0# - D# / 2#, 0, X0# - H#, Y0# - D# / 2# + (H# - E#), 0)

End Sub

' Round Head Bolt  Round Head Bolt  Round Head Bolt  Round Head Bolt
' Round Head Bolt  Round Head Bolt  Round Head Bolt  Round Head Bolt


Public Sub RHBOLT()

Dim App As Application
Dim ActDr As Drawing
Dim Grs As Graphics
Dim Gr As Graphic
Dim grfChild As Graphic
    Set App = IMSIGX.Application
    Set ActDr = App.ActiveDrawing
    Set Grs = ActDr.Graphics
    Set Gr = Grs.Add(gkGroup)

    
    'Add child Graphics
Dim X0#, Y0#, X1#, Y1#, t#
Dim D#, L#, E#, F#, s#, del#, dd#
Dim W#, H#

    X0# = 2#
    Y0# = 2#
    
    frmBolt.Image1.Visible = False
    frmBolt.Image2.Visible = True
    frmBolt.Image3.Visible = False
    frmBolt.Show

    dd = CDbl(frmBolt.TextBox1.Text)
    L = CDbl(frmBolt.TextBox2.Text)

               
    D# = 2.1 * dd#
    H# = 0.531 * dd#
    E# = 0.8 * H#
    F# = D# / 4#
    s# = (L# - H#) / 2#
    del# = 0.1 * dd#

'1
 Set grfChild = Gr.Graphics.AddLineSingle(X0#, Y0# + dd# / 2#, 0, X0# + L# - del#, Y0# + dd# / 2#, 0)
'2
 Set grfChild = Gr.Graphics.AddLineSingle(X0# + L# - del#, Y0# + dd# / 2#, 0, X0# + L# - del#, Y0# - dd# / 2#, 0)
'3
 Set grfChild = Gr.Graphics.AddLineSingle(X0#, Y0# - dd# / 2#, 0, X0# + L# - del#, Y0# - dd# / 2#, 0)
'4
 Set grfChild = Gr.Graphics.AddLineSingle(X0#, Y0# + D# / 2#, 0, X0#, Y0# - D# / 2#, 0)
'7
 Set grfChild = Gr.Graphics.AddLineSingle(X0# + (L# - s#), Y0# + dd# / 2#, 0, X0# + (L# - s#), Y0# - dd# / 2#, 0)
'8
 Set grfChild = Gr.Graphics.AddLineSingle(X0# + (L# - del#), Y0# + dd# / 2#, 0, X0# + L#, Y0# + dd# / 2# - del#, 0)
'9
 Set grfChild = Gr.Graphics.AddLineSingle(X0# + L#, Y0# + dd# / 2# - del#, 0, X0# + L#, Y0# - dd# / 2# + del#, 0)
'10
 Set grfChild = Gr.Graphics.AddLineSingle(X0# + (L# - del#), Y0# - dd# / 2#, 0, X0# + L#, Y0# - dd# / 2# + del#, 0)
'12
 Set grfChild = Gr.Graphics.AddArcTriplePoint(X0, Y0 - D / 2#, 0, X0 - H, Y0, 0, X0, Y0 + D / 2#, 0)
'14
 Set grfChild = Gr.Graphics.AddLineSingle(X0# + (L# - s#), Y0# + dd# / 2# - del#, 0, X0# + L#, Y0# + dd# / 2# - del#, 0)
'15
 Set grfChild = Gr.Graphics.AddLineSingle(X0# + (L# - s#), Y0# - dd# / 2# + del#, 0, X0# + L#, Y0# - dd# / 2# + del#, 0)

End Sub


' Round Head Square Neck Bolt  Round Head Square Neck Bolt
' Round Head Square Neck Bolt  Round Head Square Neck Bolt



Public Sub RHSNBOLT()

Dim App As Application
Dim ActDr As Drawing
Dim Grs As Graphics
Dim Gr As Graphic
Dim grfChild As Graphic
    Set App = IMSIGX.Application
    Set ActDr = App.ActiveDrawing
    Set Grs = ActDr.Graphics
    Set Gr = Grs.Add(gkGroup)

    
    'Add child Graphics
Dim X0#, Y0#, X1#, Y1#, t#
Dim D#, L#, E#, F#, s#, del#, dd#
Dim W#, H#, P#

    X0# = 2#
    Y0# = 2#
    
    frmBolt.Image1.Visible = False
    frmBolt.Image2.Visible = False
    frmBolt.Image3.Visible = True

    frmBolt.Show
    dd = CDbl(frmBolt.TextBox1.Text)
    L = CDbl(frmBolt.TextBox2.Text)
               
    D# = 2.1 * dd#
    H# = 0.531 * dd#
    P# = 0.531 * dd#
    E# = 0.8 * H#
    W# = 1.41 * dd#
    del# = 0.1 * dd#
    
    '4
     Set grfChild = Gr.Graphics.AddLineSingle(X0#, Y0# + D# / 2#, 0, X0#, Y0# - D# / 2#, 0)
    '7
     Set grfChild = Gr.Graphics.AddLineSingle(X0# + L / 2#, Y0# + dd# / 2#, 0, X0# + L / 2#, Y0# - dd# / 2#, 0)
    '8
     Set grfChild = Gr.Graphics.AddLineSingle(X0# + (L# - del#), Y0# + dd# / 2#, 0, X0# + L#, Y0# + dd# / 2# - del#, 0)
    '9
     Set grfChild = Gr.Graphics.AddLineSingle(X0# + L#, Y0# + dd# / 2# - del#, 0, X0# + L#, Y0# - dd# / 2# + del#, 0)
    '10
     Set grfChild = Gr.Graphics.AddLineSingle(X0# + (L# - del#), Y0# - dd# / 2#, 0, X0# + L#, Y0# - dd# / 2# + del#, 0)
    '12
     Set grfChild = Gr.Graphics.AddArcTriplePoint(X0, Y0 - D / 2#, 0, X0 - H, Y0, 0, X0, Y0 + D / 2#, 0)
    '14
     Set grfChild = Gr.Graphics.AddLineSingle(X0 + L / 2#, Y0 + dd / 2# - del, 0, X0 + L, Y0 + dd / 2# - del, 0)
    '15
     Set grfChild = Gr.Graphics.AddLineSingle(X0 + L / 2#, Y0 - dd / 2# + del, 0, X0 + L, Y0 - dd / 2# + del, 0)
    '16
     Set grfChild = Gr.Graphics.AddLineSingle(X0, Y0 - W / 2#, 0, X0 + E, Y0 - W / 2#, 0)
    '17
     Set grfChild = Gr.Graphics.AddLineSingle(X0, Y0, 0, X0 + E, Y0, 0)
    '18
     Set grfChild = Gr.Graphics.AddLineSingle(X0, Y0 + W / 2#, 0, X0 + E, Y0 + W / 2#, 0)
    '19
     Set grfChild = Gr.Graphics.AddArcTriplePoint(X0 + E, Y0 - W / 2#, 0, X0 + P, Y0 - W / 4#, 0, X0 + E, Y0, 0)
    '20
     Set grfChild = Gr.Graphics.AddArcTriplePoint(X0 + E, Y0, 0, X0 + P, Y0 + W / 4#, 0, X0 + E, Y0 + W / 2#, 0)
    
    Dim R#
    R = (W * W / 4 + (P - E) * (P - E)) / (2# * (P - E))
    X1 = P - R
    Y1 = W / 4#
    X1 = X1 + Sqr(R * R - (dd / 2# - Y1) * (dd / 2# - Y1))
    X1 = X1 + X0
    '1
     Set grfChild = Gr.Graphics.AddLineSingle(X1#, Y0# + dd# / 2#, 0, X0# + L# - del#, Y0# + dd# / 2#, 0)
    '2
     Set grfChild = Gr.Graphics.AddLineSingle(X0# + L# - del#, Y0# + dd# / 2#, 0, X0# + L# - del#, Y0# - dd# / 2#, 0)
    '3
     Set grfChild = Gr.Graphics.AddLineSingle(X1#, Y0# - dd# / 2#, 0, X0# + L# - del#, Y0# - dd# / 2#, 0)
End Sub

