Attribute VB_Name = "SDKLineMainmodule"
'******************************************************************'
'*                                                                *'
'*                      TurboCAD for Windows                      *'
'*                   Copyright (c) 1993 - 2006                    *'
'*             International Microcomputer Software, Inc.         *'
'*                            (IMSI)                              *'
'*                      All rights reserved.                      *'
'*                                                                *'
'******************************************************************'
' This sample demostrates how to use PointSnapped event
Public m_theToolEvents  As IToolEvents
Public m_iConnectId  As Long
Public m_bRun() As Boolean
Public m_tcApp  As Application
Public m_ptcTool As Tool
Public T As tcEventsHandler
Public m_ActiveTool As SDKLineTools
Public m_lLineColor As Long
Public ghHook As Long

Const NUM_LMITEMS = 2

Enum SDKLineTools
   SDKLine = 0
   SDKPolyline = 1
End Enum
Public Enum ToolStatus
   iStarted = 0
   iFirstClick = 1
   iSecondClick = 2
End Enum
Type POINTAPI
    X As Long
    Y As Long
End Type
Public Const WH_KEYBOARD = 2
Public Const VK_SHIFT = &H10
Public Declare Function CallNextHookEx Lib "user32" (ByVal hHook As Long, ByVal ncode As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer
Public Declare Function SetWindowsHookEx Lib "user32" Alias "SetWindowsHookExA" (ByVal idHook As Long, ByVal lpfn As Long, ByVal hmod As Long, ByVal dwThreadId As Long) As Long
Public Declare Function UnhookWindowsHookEx Lib "user32" (ByVal hHook As Long) As Long

Public Const NULL_BRUSH = 5
Public Const R2_XORPEN = 7

Public Declare Function SetCursorPos Lib "user32" (ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function ClientToScreen Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Public Declare Function SetROP2 Lib "gdi32" (ByVal hdc As Long, ByVal nDrawMode As Long) As Long
Public Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, lpPoint As POINTAPI) As Long
Public Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Public Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Public Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Public Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long



Public Function KeyboardProc(ByVal idHook As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    'if idHook is less than zero, no further processing is required
    'MsgBox "idHook " & idHook
    If idHook < 0 Then
        'call the next hook
        KeyboardProc = CallNextHookEx(ghHook, idHook, wParam, ByVal lParam)
    Else
        'check if SHIFT-S is pressed
        'If (GetKeyState(VK_SHIFT) And &HF0000000) And wParam = asc("S") Then
        '    'show the result
        '    Form1.Print "Shift-S pressed ..."
        'End If
        'MsgBox "wParam= " & CStr(wParam) & " asc(Enter) = " & Asc("ENTER") & " lParams = " & lParams
        MsgBox "Entered into hook wParam = " & wParam
        
        If (wParam = Asc("TAB") Or wParam = Asc("ENTER")) Then
            ' probably values in edit bar for our tool are changed
            MsgBox "value is changed"
        End If
        
        'call the next hook
        KeyboardProc = CallNextHookEx(ghHook, idHook, wParam, ByVal lParam)
    End If
End Function

Public Sub SDKLineToolAddInspectorBarFields(ByVal bAdd As Boolean)
    
    Dim gxProps As Properties
    Dim gxProp As Property
    
    Dim nProps As Long
    Dim lFlags As Long
    Dim pxdbTool As IToolEvents
    On Error GoTo ErrorHandler
    Set gxProps = m_ptcTool.Properties

    If bAdd = True Then
        nProps = gxProps.Count
        If nProps = 0 Then
            With gxProps
                .Add "Prop 1", 0, 0, 1
                .Add "Prop 2", 0, 0, 2
                .Add "Prop 3", 0, 0, 3
            End With
        Else
        End If
    End If
    If bAdd = True Then
        lFlags = 1
    Else
        lFlags = 2
    End If
    Set pxdbTool = m_ptcTool.Application.ToolEvents
    pxdbTool.ToolChangeProperties m_ptcTool, lFlags
    Set pxdbTool = Nothing
    If bAdd = True And ghHook = 0 Then
        'ghHook = SetWindowsHookEx(WH_KEYBOARD, AddressOf KeyboardProc, App.hInstance, App.ThreadID)
    Else
        UnhookWindowsHookEx ghHook
        ghHook = 0
    End If
    'Set gxProps = Nothing
    Exit Sub
ErrorHandler:
    MsgBox "AddInspectorBarFields sub failed " & Err.Description
    Err.Clear
    Set gxProps = Nothing
    Set pxdbTool = Nothing
    
End Sub

Public Function SDKLineToolAddLocalMenu(bAddItems As Boolean)
    On Error GoTo ErrorHandler
    Dim MenuCaptions(NUM_LMITEMS) As String
    Dim StatusPrompts(NUM_LMITEMS) As String
    Dim Enabled(NUM_LMITEMS) As Boolean
    Dim Checked(NUM_LMITEMS) As Boolean
    Dim varCaptions As Variant
    Dim varPrompts As Variant
    Dim varEnabled As Variant
    Dim varChecked As Variant
    If m_theToolEvents Is Nothing Then
        Exit Function
    End If
    If (bAddItems = True) Then
        ' fill array of local menu items
        MenuCaptions(0) = "Add InspectorBar fields"
        StatusPrompts(0) = "Add the inspector bar fields for the tool"
        Enabled(0) = True
        Checked(0) = False
        MenuCaptions(1) = "Remove InspectorBar fields"
        StatusPrompts(1) = "Remove InspectorBar fields"
        Enabled(1) = True
        If b_ToolMode = 1 Then
            Checked(1) = True
        Else
            Checked(1) = False
        End If
        
        MenuCaptions(2) = "SDK Line Finish"
        StatusPrompts(2) = "SDK Line Finish"
        Enabled(2) = True
        Checked(2) = False
        
        varCaptions = MenuCaptions
        varPrompts = StatusPrompts
        varEnabled = Enabled
        varChecked = Checked
        m_theToolEvents.ToolChangeCommands T, 3, varCaptions, varPrompts, varEnabled, varChecked, True
     
    Else
        ' remove items from tool's local menu
        m_theToolEvents.ToolChangeCommands T, 0, , , , , False
    End If
    Exit Function
ErrorHandler:
    MsgBox "AddLocalMenu function failed " & Err.Description

End Function

